diff --git a/sysdeps/powerpc/fpu/libm-test-ulps b/sysdeps/powerpc/fpu/libm-test-ulps
index 5a78b0b..09abf1f 100644
--- a/sysdeps/powerpc/fpu/libm-test-ulps
+++ b/sysdeps/powerpc/fpu/libm-test-ulps
@@ -8,7 +8,9 @@ ildouble: 1
 ldouble: 1
 
 Function: "acos_downward":
+double: 1
 float: 1
+idouble: 1
 ifloat: 1
 ildouble: 3
 ldouble: 3
@@ -30,36 +32,36 @@ ildouble: 2
 ldouble: 2
 
 Function: "acosh":
-double: 1
+double: 2
 float: 2
-idouble: 1
+idouble: 2
 ifloat: 2
 ildouble: 1
 ldouble: 1
 
 Function: "acosh_downward":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
-ildouble: 2
-ldouble: 2
+ifloat: 2
+ildouble: 3
+ldouble: 3
 
 Function: "acosh_towardzero":
 double: 2
-float: 1
+float: 2
 idouble: 2
-ifloat: 1
-ildouble: 2
-ldouble: 2
+ifloat: 2
+ildouble: 3
+ldouble: 3
 
 Function: "acosh_upward":
 double: 2
-float: 1
+float: 2
 idouble: 2
-ifloat: 1
+ifloat: 2
 ildouble: 3
-ldouble: 3
+ldouble: 4
 
 Function: "asin":
 float: 1
@@ -76,7 +78,9 @@ ildouble: 2
 ldouble: 2
 
 Function: "asin_towardzero":
+double: 1
 float: 1
+idouble: 1
 ifloat: 1
 ildouble: 1
 ldouble: 1
@@ -184,18 +188,18 @@ ildouble: 2
 ldouble: 2
 
 Function: "atanh":
-double: 1
+double: 2
 float: 2
-idouble: 1
+idouble: 2
 ifloat: 2
 ildouble: 2
 ldouble: 2
 
 Function: "atanh_downward":
 double: 3
-float: 2
+float: 3
 idouble: 3
-ifloat: 2
+ifloat: 3
 ildouble: 3
 ldouble: 3
 
@@ -208,9 +212,9 @@ ildouble: 2
 ldouble: 2
 
 Function: "atanh_upward":
-double: 2
+double: 3
 float: 3
-idouble: 2
+idouble: 3
 ifloat: 3
 ildouble: 3
 ldouble: 3
@@ -236,8 +240,8 @@ ldouble: 1
 Function: "cabs_upward":
 double: 1
 idouble: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: Real part of "cacos":
 double: 1
@@ -368,16 +372,18 @@ ildouble: 4
 ldouble: 4
 
 Function: "carg":
+double: 1
 float: 1
+idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "carg_downward":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
+ifloat: 2
 ildouble: 5
 ldouble: 5
 
@@ -394,8 +400,8 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: Real part of "casin":
 double: 1
@@ -658,21 +664,21 @@ double: 4
 float: 1
 idouble: 4
 ifloat: 1
-ildouble: 4
-ldouble: 4
+ildouble: 5
+ldouble: 5
 
 Function: "cbrt_towardzero":
-double: 2
+double: 3
 float: 1
-idouble: 2
+idouble: 3
 ifloat: 1
 ildouble: 3
 ldouble: 3
 
 Function: "cbrt_upward":
-double: 4
+double: 5
 float: 1
-idouble: 4
+idouble: 5
 ifloat: 1
 ildouble: 2
 ldouble: 2
@@ -887,9 +893,9 @@ ldouble: 2
 
 Function: Real part of "clog10":
 double: 3
-float: 3
+float: 4
 idouble: 3
-ifloat: 3
+ifloat: 4
 ildouble: 3
 ldouble: 3
 
@@ -919,9 +925,9 @@ ldouble: 7
 
 Function: Real part of "clog10_towardzero":
 double: 5
-float: 4
+float: 5
 idouble: 5
-ifloat: 4
+ifloat: 5
 ildouble: 9
 ldouble: 9
 
@@ -930,8 +936,8 @@ double: 2
 float: 4
 idouble: 2
 ifloat: 4
-ildouble: 7
-ldouble: 7
+ildouble: 8
+ldouble: 8
 
 Function: Real part of "clog10_upward":
 double: 8
@@ -943,11 +949,11 @@ ldouble: 10
 
 Function: Imaginary part of "clog10_upward":
 double: 2
-float: 3
+float: 4
 idouble: 2
-ifloat: 3
-ildouble: 6
-ldouble: 6
+ifloat: 4
+ildouble: 7
+ldouble: 7
 
 Function: Real part of "clog_downward":
 double: 7
@@ -975,11 +981,11 @@ ldouble: 10
 
 Function: Imaginary part of "clog_towardzero":
 double: 1
-float: 2
+float: 3
 idouble: 1
-ifloat: 2
-ildouble: 6
-ldouble: 6
+ifloat: 3
+ildouble: 7
+ldouble: 7
 
 Function: Real part of "clog_upward":
 double: 8
@@ -994,8 +1000,8 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "cos":
 float: 1
@@ -1260,9 +1266,9 @@ ildouble: 1
 ldouble: 1
 
 Function: Real part of "csqrt_downward":
-double: 4
+double: 5
 float: 4
-idouble: 4
+idouble: 5
 ifloat: 4
 ildouble: 4
 ldouble: 4
@@ -1272,24 +1278,24 @@ double: 4
 float: 3
 idouble: 4
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 5
+ldouble: 5
 
 Function: Real part of "csqrt_towardzero":
-double: 3
+double: 4
 float: 3
-idouble: 3
+idouble: 4
 ifloat: 3
-ildouble: 4
-ldouble: 4
+ildouble: 5
+ldouble: 5
 
 Function: Imaginary part of "csqrt_towardzero":
 double: 4
 float: 3
 idouble: 4
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 5
+ldouble: 5
 
 Function: Real part of "csqrt_upward":
 double: 5
@@ -1456,14 +1462,16 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "erf_upward":
+double: 1
 float: 1
+idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 3
+ldouble: 3
 
 Function: "erfc":
 double: 2
@@ -1478,8 +1486,8 @@ double: 3
 float: 4
 idouble: 3
 ifloat: 4
-ildouble: 7
-ldouble: 7
+ildouble: 10
+ldouble: 10
 
 Function: "erfc_towardzero":
 double: 3
@@ -1494,10 +1502,12 @@ double: 3
 float: 4
 idouble: 3
 ifloat: 4
-ildouble: 6
-ldouble: 6
+ildouble: 7
+ldouble: 7
 
 Function: "exp":
+float: 1
+ifloat: 1
 ildouble: 1
 ldouble: 1
 
@@ -1512,16 +1522,16 @@ double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 4
-ldouble: 4
+ildouble: 9
+ldouble: 9
 
 Function: "exp10_towardzero":
 double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 4
-ldouble: 4
+ildouble: 9
+ldouble: 9
 
 Function: "exp10_upward":
 double: 2
@@ -1533,9 +1543,11 @@ ldouble: 4
 
 Function: "exp2":
 double: 1
+float: 1
 idouble: 1
-ildouble: 1
-ldouble: 1
+ifloat: 1
+ildouble: 2
+ldouble: 2
 
 Function: "exp2_downward":
 double: 1
@@ -1564,14 +1576,14 @@ ldouble: 2
 Function: "exp_downward":
 double: 1
 idouble: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "exp_towardzero":
 double: 1
 idouble: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "exp_upward":
 double: 1
@@ -1597,9 +1609,9 @@ ldouble: 3
 
 Function: "expm1_towardzero":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
+ifloat: 2
 ildouble: 5
 ldouble: 5
 
@@ -1627,37 +1639,53 @@ Function: "fma_upward":
 ildouble: 3
 ldouble: 3
 
-Function: "gamma":
-double: 1
-float: 1
-idouble: 1
-ifloat: 1
+Function: "fmod":
 ildouble: 1
 ldouble: 1
 
-Function: "gamma_downward":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
-ildouble: 2
-ldouble: 2
+Function: "fmod_downward":
+ildouble: 1
+ldouble: 1
 
-Function: "gamma_towardzero":
+Function: "fmod_towardzero":
+ildouble: 1
+ldouble: 1
+
+Function: "fmod_upward":
+ildouble: 1
+ldouble: 1
+
+Function: "gamma":
 double: 3
-float: 3
+float: 4
 idouble: 3
-ifloat: 3
+ifloat: 4
 ildouble: 3
 ldouble: 3
 
-Function: "gamma_upward":
-double: 3
+Function: "gamma_downward":
+double: 4
+float: 4
+idouble: 4
+ifloat: 4
+ildouble: 14
+ldouble: 14
+
+Function: "gamma_towardzero":
+double: 4
 float: 3
-idouble: 3
+idouble: 4
 ifloat: 3
-ildouble: 6
-ldouble: 6
+ildouble: 14
+ldouble: 14
+
+Function: "gamma_upward":
+double: 4
+float: 5
+idouble: 4
+ifloat: 5
+ildouble: 10
+ldouble: 10
 
 Function: "hypot":
 double: 1
@@ -1780,36 +1808,36 @@ ildouble: 5
 ldouble: 5
 
 Function: "lgamma":
-double: 1
-float: 1
-idouble: 1
-ifloat: 1
-ildouble: 1
-ldouble: 1
-
-Function: "lgamma_downward":
 double: 3
-float: 3
+float: 4
 idouble: 3
-ifloat: 3
-ildouble: 2
-ldouble: 2
+ifloat: 4
+ildouble: 3
+ldouble: 3
+
+Function: "lgamma_downward":
+double: 4
+float: 4
+idouble: 4
+ifloat: 4
+ildouble: 14
+ldouble: 14
 
 Function: "lgamma_towardzero":
-double: 3
+double: 4
 float: 3
-idouble: 3
+idouble: 4
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 14
+ldouble: 14
 
 Function: "lgamma_upward":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
-ildouble: 6
-ldouble: 6
+double: 4
+float: 5
+idouble: 4
+ifloat: 5
+ildouble: 10
+ldouble: 10
 
 Function: "log":
 float: 1
@@ -1838,8 +1866,8 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log10_upward":
 double: 2
@@ -1854,8 +1882,8 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log1p_downward":
 double: 1
@@ -1870,16 +1898,16 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "log1p_upward":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log2":
 double: 1
@@ -1902,16 +1930,16 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 4
+ldouble: 4
 
 Function: "log2_upward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 1
-ldouble: 1
+ildouble: 4
+ldouble: 4
 
 Function: "log_downward":
 float: 2
@@ -1926,7 +1954,9 @@ ildouble: 2
 ldouble: 2
 
 Function: "log_upward":
+double: 1
 float: 1
+idouble: 1
 ifloat: 1
 ildouble: 1
 ldouble: 1
@@ -1948,16 +1978,16 @@ double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 4
-ldouble: 4
+ildouble: 9
+ldouble: 9
 
 Function: "pow10_towardzero":
 double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 4
-ldouble: 4
+ildouble: 9
+ldouble: 9
 
 Function: "pow10_upward":
 double: 2
@@ -2002,8 +2032,8 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "sin_towardzero":
 double: 1
@@ -2045,9 +2075,9 @@ ldouble: 7
 
 Function: "sincos_upward":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
+ifloat: 2
 ildouble: 7
 ldouble: 7
 
@@ -2056,24 +2086,24 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "sinh_downward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 5
-ldouble: 5
+ildouble: 6
+ldouble: 6
 
 Function: "sinh_towardzero":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 3
-ldouble: 3
+ildouble: 6
+ldouble: 6
 
 Function: "sinh_upward":
 double: 3
@@ -2110,8 +2140,8 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "tan_towardzero":
 double: 1
@@ -2150,46 +2180,46 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "tanh_upward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 6
+ldouble: 6
 
 Function: "tgamma":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
 ildouble: 5
 ldouble: 5
 
 Function: "tgamma_downward":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
 ildouble: 6
 ldouble: 6
 
 Function: "tgamma_towardzero":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
 ildouble: 5
 ldouble: 5
 
 Function: "tgamma_upward":
-double: 3
-float: 3
-idouble: 3
-ifloat: 3
+double: 4
+float: 4
+idouble: 4
+ifloat: 4
 ildouble: 5
 ldouble: 5
 