diff --git a/sysdeps/alpha/fpu/libm-test-ulps b/sysdeps/alpha/fpu/libm-test-ulps
index 9ac946f..6ec37f7 100644
--- a/sysdeps/alpha/fpu/libm-test-ulps
+++ b/sysdeps/alpha/fpu/libm-test-ulps
@@ -4,6 +4,8 @@
 Function: "acos":
 float: 1
 ifloat: 1
+ildouble: 1
+ldouble: 1
 
 Function: "acos_downward":
 double: 1
@@ -30,34 +32,34 @@ ildouble: 1
 ldouble: 1
 
 Function: "acosh":
-double: 1
+double: 2
 float: 2
-idouble: 1
+idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
-
-Function: "acosh_downward":
-double: 1
-float: 1
-idouble: 1
-ifloat: 1
 ildouble: 2
 ldouble: 2
 
+Function: "acosh_downward":
+double: 2
+float: 2
+idouble: 2
+ifloat: 2
+ildouble: 3
+ldouble: 3
+
 Function: "acosh_towardzero":
 double: 2
-float: 1
+float: 2
 idouble: 2
-ifloat: 1
-ildouble: 1
-ldouble: 1
+ifloat: 2
+ildouble: 2
+ldouble: 2
 
 Function: "acosh_upward":
 double: 2
-float: 1
+float: 2
 idouble: 2
-ifloat: 1
+ifloat: 2
 ildouble: 2
 ldouble: 2
 
@@ -72,8 +74,8 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "asin_towardzero":
 double: 1
@@ -88,24 +90,24 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "asinh":
 double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 3
+ldouble: 3
 
 Function: "asinh_downward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "asinh_towardzero":
 double: 2
@@ -120,8 +122,8 @@ double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "atan":
 float: 1
@@ -140,16 +142,16 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "atan2_towardzero":
 double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "atan2_upward":
 double: 1
@@ -180,24 +182,24 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "atanh":
-double: 1
+double: 2
 float: 2
-idouble: 1
+idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "atanh_downward":
 double: 3
-float: 2
+float: 3
 idouble: 3
-ifloat: 2
-ildouble: 3
-ldouble: 3
+ifloat: 3
+ildouble: 4
+ldouble: 4
 
 Function: "atanh_towardzero":
 double: 2
@@ -208,28 +210,36 @@ ildouble: 2
 ldouble: 2
 
 Function: "atanh_upward":
-double: 2
+double: 3
 float: 3
-idouble: 2
+idouble: 3
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "cabs":
 double: 1
 idouble: 1
+ildouble: 1
+ldouble: 1
 
 Function: "cabs_downward":
 double: 1
 idouble: 1
+ildouble: 1
+ldouble: 1
 
 Function: "cabs_towardzero":
 double: 1
 idouble: 1
+ildouble: 1
+ldouble: 1
 
 Function: "cabs_upward":
 double: 1
 idouble: 1
+ildouble: 1
+ldouble: 1
 
 Function: Real part of "cacos":
 double: 1
@@ -362,32 +372,32 @@ ldouble: 3
 Function: "carg":
 float: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "carg_downward":
 double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "carg_towardzero":
 double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "carg_upward":
 double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: Real part of "casin":
 double: 1
@@ -564,9 +574,7 @@ ildouble: 3
 ldouble: 3
 
 Function: Real part of "catan_upward":
-double: 1
 float: 1
-idouble: 1
 ifloat: 1
 ildouble: 1
 ldouble: 1
@@ -634,9 +642,7 @@ ildouble: 4
 ldouble: 4
 
 Function: Imaginary part of "catanh_upward":
-double: 1
 float: 1
-idouble: 1
 ifloat: 1
 ildouble: 1
 ldouble: 1
@@ -666,9 +672,9 @@ ildouble: 1
 ldouble: 1
 
 Function: "cbrt_upward":
-double: 4
+double: 5
 float: 1
-idouble: 4
+idouble: 5
 ifloat: 1
 ildouble: 1
 ldouble: 1
@@ -817,13 +823,61 @@ ifloat: 2
 ildouble: 1
 ldouble: 1
 
+Function: Real part of "cexp_downward":
+double: 1
+float: 2
+idouble: 1
+ifloat: 2
+ildouble: 2
+ldouble: 2
+
+Function: Imaginary part of "cexp_downward":
+double: 1
+float: 3
+idouble: 1
+ifloat: 3
+ildouble: 2
+ldouble: 2
+
+Function: Real part of "cexp_towardzero":
+double: 1
+float: 2
+idouble: 1
+ifloat: 2
+ildouble: 2
+ldouble: 2
+
+Function: Imaginary part of "cexp_towardzero":
+double: 1
+float: 3
+idouble: 1
+ifloat: 3
+ildouble: 2
+ldouble: 2
+
+Function: Real part of "cexp_upward":
+double: 1
+float: 2
+idouble: 1
+ifloat: 2
+ildouble: 3
+ldouble: 3
+
+Function: Imaginary part of "cexp_upward":
+double: 1
+float: 2
+idouble: 1
+ifloat: 2
+ildouble: 3
+ldouble: 3
+
 Function: Real part of "clog":
 double: 3
-float: 2
+float: 3
 idouble: 3
-ifloat: 2
-ildouble: 4
-ldouble: 4
+ifloat: 3
+ildouble: 2
+ldouble: 2
 
 Function: Imaginary part of "clog":
 float: 1
@@ -833,11 +887,11 @@ ldouble: 1
 
 Function: Real part of "clog10":
 double: 3
-float: 3
+float: 4
 idouble: 3
-ifloat: 3
-ildouble: 4
-ldouble: 4
+ifloat: 4
+ildouble: 2
+ldouble: 2
 
 Function: Imaginary part of "clog10":
 double: 2
@@ -848,60 +902,60 @@ ildouble: 2
 ldouble: 2
 
 Function: Real part of "clog10_downward":
-double: 6
-float: 6
-idouble: 6
-ifloat: 6
-ildouble: 5
-ldouble: 5
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 3
+ldouble: 3
 
 Function: Imaginary part of "clog10_downward":
-double: 3
+double: 2
 float: 4
-idouble: 3
+idouble: 2
 ifloat: 4
 ildouble: 3
 ldouble: 3
 
 Function: Real part of "clog10_towardzero":
 double: 5
-float: 4
+float: 5
 idouble: 5
-ifloat: 4
-ildouble: 6
-ldouble: 6
+ifloat: 5
+ildouble: 4
+ldouble: 4
 
 Function: Imaginary part of "clog10_towardzero":
-double: 3
+double: 2
 float: 4
-idouble: 3
+idouble: 2
 ifloat: 4
 ildouble: 3
 ldouble: 3
 
 Function: Real part of "clog10_upward":
-double: 8
+double: 6
 float: 5
-idouble: 8
+idouble: 6
 ifloat: 5
-ildouble: 5
-ldouble: 5
+ildouble: 4
+ldouble: 4
 
 Function: Imaginary part of "clog10_upward":
 double: 2
-float: 3
+float: 4
 idouble: 2
-ifloat: 3
+ifloat: 4
 ildouble: 3
 ldouble: 3
 
 Function: Real part of "clog_downward":
-double: 7
-float: 5
-idouble: 7
-ifloat: 5
-ildouble: 6
-ldouble: 6
+double: 4
+float: 3
+idouble: 4
+ifloat: 3
+ildouble: 3
+ldouble: 3
 
 Function: Imaginary part of "clog_downward":
 double: 1
@@ -912,33 +966,33 @@ ildouble: 2
 ldouble: 2
 
 Function: Real part of "clog_towardzero":
-double: 7
-float: 5
-idouble: 7
-ifloat: 5
-ildouble: 6
-ldouble: 6
+double: 4
+float: 4
+idouble: 4
+ifloat: 4
+ildouble: 3
+ldouble: 3
 
 Function: Imaginary part of "clog_towardzero":
 double: 1
-float: 2
+float: 3
 idouble: 1
-ifloat: 2
+ifloat: 3
 ildouble: 2
 ldouble: 2
 
 Function: Real part of "clog_upward":
-double: 8
-float: 5
-idouble: 8
-ifloat: 5
-ildouble: 6
-ldouble: 6
+double: 4
+float: 3
+idouble: 4
+ifloat: 3
+ildouble: 4
+ldouble: 4
 
 Function: Imaginary part of "clog_upward":
-double: 2
+double: 1
 float: 2
-idouble: 2
+idouble: 1
 ifloat: 2
 ildouble: 2
 ldouble: 2
@@ -1028,9 +1082,9 @@ ildouble: 6
 ldouble: 6
 
 Function: Imaginary part of "cpow_downward":
-double: 2
+double: 1
 float: 2
-idouble: 2
+idouble: 1
 ifloat: 2
 ildouble: 2
 ldouble: 2
@@ -1044,9 +1098,9 @@ ildouble: 6
 ldouble: 6
 
 Function: Imaginary part of "cpow_towardzero":
-double: 2
+double: 1
 float: 2
-idouble: 2
+idouble: 1
 ifloat: 2
 ildouble: 2
 ldouble: 2
@@ -1089,11 +1143,11 @@ ldouble: 2
 
 Function: Imaginary part of "csin_downward":
 double: 1
-float: 2
+float: 1
 idouble: 1
-ifloat: 2
-ildouble: 3
-ldouble: 3
+ifloat: 1
+ildouble: 2
+ldouble: 2
 
 Function: Real part of "csin_towardzero":
 double: 2
@@ -1104,26 +1158,26 @@ ildouble: 2
 ldouble: 2
 
 Function: Imaginary part of "csin_towardzero":
+double: 1
+float: 1
+idouble: 1
+ifloat: 1
+ildouble: 2
+ldouble: 2
+
+Function: Real part of "csin_upward":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 3
-ldouble: 3
-
-Function: Real part of "csin_upward":
-double: 1
-float: 3
-idouble: 1
-ifloat: 3
 ildouble: 2
 ldouble: 2
 
 Function: Imaginary part of "csin_upward":
 double: 1
-float: 3
+float: 2
 idouble: 1
-ifloat: 3
+ifloat: 2
 ildouble: 3
 ldouble: 3
 
@@ -1142,12 +1196,12 @@ ildouble: 1
 ldouble: 1
 
 Function: Real part of "csinh_downward":
-double: 1
-float: 1
-idouble: 1
-ifloat: 1
-ildouble: 3
-ldouble: 3
+double: 2
+float: 2
+idouble: 2
+ifloat: 2
+ildouble: 2
+ldouble: 2
 
 Function: Imaginary part of "csinh_downward":
 double: 2
@@ -1162,30 +1216,30 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 3
-ldouble: 3
+ildouble: 2
+ldouble: 2
 
 Function: Imaginary part of "csinh_towardzero":
 double: 2
 float: 3
 idouble: 2
 ifloat: 3
-ildouble: 3
-ldouble: 3
+ildouble: 2
+ldouble: 2
 
 Function: Real part of "csinh_upward":
 double: 1
-float: 3
+float: 2
 idouble: 1
-ifloat: 3
+ifloat: 2
 ildouble: 3
 ldouble: 3
 
 Function: Imaginary part of "csinh_upward":
 double: 2
-float: 3
+float: 2
 idouble: 2
-ifloat: 3
+ifloat: 2
 ildouble: 2
 ldouble: 2
 
@@ -1194,64 +1248,64 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: Imaginary part of "csqrt":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: Real part of "csqrt_downward":
-double: 4
+double: 5
 float: 4
-idouble: 4
+idouble: 5
 ifloat: 4
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: Imaginary part of "csqrt_downward":
 double: 4
 float: 3
 idouble: 4
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: Real part of "csqrt_towardzero":
-double: 3
+double: 4
 float: 3
-idouble: 3
+idouble: 4
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: Imaginary part of "csqrt_towardzero":
 double: 4
 float: 3
 idouble: 4
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: Real part of "csqrt_upward":
 double: 5
 float: 4
 idouble: 5
 ifloat: 4
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: Imaginary part of "csqrt_upward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: Real part of "ctan":
 double: 1
@@ -1414,42 +1468,48 @@ ildouble: 2
 ldouble: 2
 
 Function: "erfc":
-double: 2
+double: 3
 float: 2
-idouble: 2
+idouble: 3
 ifloat: 2
 ildouble: 2
 ldouble: 2
 
 Function: "erfc_downward":
-double: 4
+double: 5
 float: 6
-idouble: 4
+idouble: 5
 ifloat: 6
-ildouble: 3
-ldouble: 3
+ildouble: 5
+ldouble: 5
 
 Function: "erfc_towardzero":
 double: 3
 float: 4
 idouble: 3
 ifloat: 4
-ildouble: 3
-ldouble: 3
+ildouble: 4
+ldouble: 4
 
 Function: "erfc_upward":
-double: 4
+double: 5
 float: 6
-idouble: 4
+idouble: 5
 ifloat: 6
-ildouble: 3
-ldouble: 3
+ildouble: 5
+ldouble: 5
+
+Function: "exp":
+float: 1
+ifloat: 1
+ildouble: 1
+ldouble: 1
 
 Function: "exp10":
 double: 2
 idouble: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "exp10_downward":
 double: 2
@@ -1472,8 +1532,8 @@ double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "exp2":
 double: 1
@@ -1504,8 +1564,8 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "exp_downward":
 double: 1
@@ -1537,11 +1597,11 @@ ldouble: 2
 
 Function: "expm1_towardzero":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
-ildouble: 3
-ldouble: 3
+ifloat: 2
+ildouble: 4
+ldouble: 4
 
 Function: "expm1_upward":
 double: 1
@@ -1552,36 +1612,36 @@ ildouble: 3
 ldouble: 3
 
 Function: "gamma":
-double: 2
-float: 2
-idouble: 2
-ifloat: 2
-ildouble: 1
-ldouble: 1
-
-Function: "gamma_downward":
 double: 4
-float: 3
+float: 4
 idouble: 4
-ifloat: 3
-ildouble: 2
-ldouble: 2
+ifloat: 4
+ildouble: 5
+ldouble: 5
+
+Function: "gamma_downward":
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 8
+ldouble: 8
 
 Function: "gamma_towardzero":
-double: 4
-float: 3
-idouble: 4
-ifloat: 3
-ildouble: 2
-ldouble: 2
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 5
+ldouble: 5
 
 Function: "gamma_upward":
-double: 4
-float: 3
-idouble: 4
-ifloat: 3
-ildouble: 3
-ldouble: 3
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
+ildouble: 8
+ldouble: 8
 
 Function: "hypot":
 double: 1
@@ -1679,37 +1739,61 @@ ifloat: 4
 ildouble: 7
 ldouble: 7
 
-Function: "lgamma":
-double: 2
-float: 2
-idouble: 2
-ifloat: 2
-ildouble: 1
-ldouble: 1
+Function: "jn_downward":
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
+ildouble: 8
+ldouble: 8
 
-Function: "lgamma_downward":
+Function: "jn_towardzero":
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
+ildouble: 8
+ldouble: 8
+
+Function: "jn_upward":
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
+ildouble: 7
+ldouble: 7
+
+Function: "lgamma":
 double: 4
-float: 3
+float: 4
 idouble: 4
-ifloat: 3
-ildouble: 2
-ldouble: 2
+ifloat: 4
+ildouble: 5
+ldouble: 5
+
+Function: "lgamma_downward":
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 8
+ldouble: 8
 
 Function: "lgamma_towardzero":
-double: 4
-float: 3
-idouble: 4
-ifloat: 3
-ildouble: 2
-ldouble: 2
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 5
+ldouble: 5
 
 Function: "lgamma_upward":
-double: 4
-float: 3
-idouble: 4
-ifloat: 3
-ildouble: 3
-ldouble: 3
+double: 5
+float: 5
+idouble: 5
+ifloat: 5
+ildouble: 8
+ldouble: 8
 
 Function: "log":
 float: 1
@@ -1754,48 +1838,48 @@ double: 1
 float: 1
 idouble: 1
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log1p_downward":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 3
+ldouble: 3
 
 Function: "log1p_towardzero":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 3
+ldouble: 3
 
 Function: "log1p_upward":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log2":
 double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log2_downward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 1
-ldouble: 1
+ildouble: 3
+ldouble: 3
 
 Function: "log2_towardzero":
 double: 2
@@ -1822,26 +1906,28 @@ ldouble: 1
 Function: "log_towardzero":
 float: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "log_upward":
+double: 1
 float: 2
+idouble: 1
 ifloat: 2
 ildouble: 1
 ldouble: 1
 
 Function: "pow":
-float: 3
-ifloat: 3
-ildouble: 1
-ldouble: 1
+float: 1
+ifloat: 1
+ildouble: 2
+ldouble: 2
 
 Function: "pow10":
 double: 2
 idouble: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "pow10_downward":
 double: 2
@@ -1864,30 +1950,30 @@ double: 2
 float: 1
 idouble: 2
 ifloat: 1
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "pow_downward":
 double: 1
-float: 3
+float: 1
 idouble: 1
-ifloat: 3
-ildouble: 1
-ldouble: 1
+ifloat: 1
+ildouble: 2
+ldouble: 2
 
 Function: "pow_towardzero":
 double: 1
-float: 4
+float: 1
 idouble: 1
-ifloat: 4
-ildouble: 1
-ldouble: 1
+ifloat: 1
+ildouble: 2
+ldouble: 2
 
 Function: "pow_upward":
 double: 1
-float: 4
+float: 1
 idouble: 1
-ifloat: 4
+ifloat: 1
 ildouble: 2
 ldouble: 2
 
@@ -1918,8 +2004,8 @@ double: 1
 float: 2
 idouble: 1
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "sincos":
 float: 1
@@ -1945,47 +2031,49 @@ ldouble: 2
 
 Function: "sincos_upward":
 double: 1
-float: 1
+float: 2
 idouble: 1
-ifloat: 1
-ildouble: 2
-ldouble: 2
+ifloat: 2
+ildouble: 3
+ldouble: 3
 
 Function: "sinh":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "sinh_downward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "sinh_towardzero":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "sinh_upward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 4
+ldouble: 4
 
 Function: "tan":
 float: 1
 ifloat: 1
+ildouble: 1
+ldouble: 1
 
 Function: "tan_downward":
 double: 1
@@ -2016,24 +2104,24 @@ double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 1
-ldouble: 1
+ildouble: 2
+ldouble: 2
 
 Function: "tanh_downward":
 double: 3
 float: 3
 idouble: 3
 ifloat: 3
-ildouble: 2
-ldouble: 2
+ildouble: 4
+ldouble: 4
 
 Function: "tanh_towardzero":
 double: 2
 float: 2
 idouble: 2
 ifloat: 2
-ildouble: 2
-ldouble: 2
+ildouble: 3
+ldouble: 3
 
 Function: "tanh_upward":
 double: 3
@@ -2044,10 +2132,34 @@ ildouble: 3
 ldouble: 3
 
 Function: "tgamma":
-double: 7
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 4
+ldouble: 4
+
+Function: "tgamma_downward":
+double: 5
 float: 5
-idouble: 7
+idouble: 5
 ifloat: 5
+ildouble: 5
+ldouble: 5
+
+Function: "tgamma_towardzero":
+double: 5
+float: 4
+idouble: 5
+ifloat: 4
+ildouble: 5
+ldouble: 5
+
+Function: "tgamma_upward":
+double: 4
+float: 4
+idouble: 4
+ifloat: 4
 ildouble: 4
 ldouble: 4
 